commit 595dc614f285c4ad859ab410e2c0e32026dd2dce
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Fri Nov 24 13:33:23 2006 +0000

    Debugcode entfernt.

diff --git a/bin/mozilla/am.pl b/bin/mozilla/am.pl
index b60c1fa53..70a7a387e 100644
--- a/bin/mozilla/am.pl
+++ b/bin/mozilla/am.pl
@@ -112,7 +112,6 @@ sub account_header {
 		<input type=hidden name=selecttaxkey value="$form->{selecttaxkey}">
 	      </tr>|;
 
-  #print(STDERR Dumper($form->{NEWACCOUNT}));
   if (@{ $form->{NEWACCOUNT} }) {
     if (!$form->{new_chart_valid}) {
       $form->{selectnewaccount} = "<option value=></option>";
@@ -479,7 +478,6 @@ sub form_footer {
 <input type=hidden name=password value=$form->{password}>
 
 <br>|;
-#print(STDERR "$form->{type} TYPE $form->{new_chart_valid} CHART_VALID\n");
   if ((!$form->{id}) || ($form->{id} && $form->{orphaned}) || (($form->{type} eq "account") && (!$form->{new_chart_valid}))) {
     print qq|
 <input type=submit class=submit name=action value="|
@@ -3607,9 +3605,6 @@ sub save_unit {
     }
   }
 
-  #print(STDERR Dumper($delete_units));
-  #print(STDERR Dumper($new_units));
-
   AM->save_units(\%myconfig, $form, $form->{"unit_type"}, $new_units, \@delete_units);
 
   $form->{"saved_message"} = $locale->text("The units have been saved.");
diff --git a/bin/mozilla/common.pl b/bin/mozilla/common.pl
index ed2612911..fb98b70c0 100644
--- a/bin/mozilla/common.pl
+++ b/bin/mozilla/common.pl
@@ -403,13 +403,8 @@ sub calculate_qty {
 sub calculate_alu {
   $lxdebug->enter_sub();
 
-
-
   my ($length, $weight) = split /\r\n/,$form->{formel};
 
-  #print(STDERR "$form->{formel} Formel\n");
-  #print(STDERR "$form->{description} Description\n");
-
   map({ $form->{$_} = "" } (qw(qty_alu price_alu total_alu qty_eloxal price_eloxal total_eloxal total)));
 
   if ($form->{description} =~ /.*Alupreisberechnung.*/) {
@@ -423,7 +418,6 @@ sub calculate_alu {
     $form->{total} = $form->format_amount(\%myconfig, ($form->parse_amount(\%myconfig, $form->{total_alu}) + $form->parse_amount(\%myconfig, $form->{total_eloxal})));
   }
   ($form->{description}, $null) = split /\nAlupreisberechnung/, $form->{description};
-  #map({ print(STDERR "$_ = $form->{$_}\n") } (qw(qty_alu price_alu total_alu qty_eloxal price_eloxal total_eloxal total)));
 
   my $callback = "$form->{script}?action=vendor_selection&";
   map({ $callback .= "$_=" . $form->escape($form->{$_}) . "&" }
diff --git a/bin/mozilla/ct.pl b/bin/mozilla/ct.pl
index 5cc821a45..2db7ce5b7 100644
--- a/bin/mozilla/ct.pl
+++ b/bin/mozilla/ct.pl
@@ -1598,7 +1598,6 @@ sub save {
   if ($vertreter && $form->{db} eq "customer") {
     $form->isblank("salesman_id", $locale->text("Salesman missing!"));
   }
-  print(STDERR "SHIPTO in sub save $form->{shipto_id}\n");
   &{"CT::save_$form->{db}"}("", \%myconfig, \%$form);
 
   &edit;
diff --git a/bin/mozilla/dn.pl b/bin/mozilla/dn.pl
index e79283a6d..c1d0f8bf6 100644
--- a/bin/mozilla/dn.pl
+++ b/bin/mozilla/dn.pl
@@ -586,7 +586,6 @@ sub save_dunning {
       for my $i (1 .. $form->{rowcount}) {
         $form->{"active_$i"} *= 1;
         $lastcustomer = $form->{"customer_id_$i"} unless ($lastcustomer);
-        #print(STDERR qq|LASTCUSTOMER $lastcustomer AKTUELL $form->{"customer_id_$i"} ACTIVE? $form->{"active_$i"} active $active\n Zeile $i|);
         if ($form->{"active_$i"} && ($form->{"customer_id_$i"} == $lastcustomer)) {
           if ($form->{inv_ids}) {
             $form->{inv_ids} .= qq|,$form->{"inv_id_$i"}|;
@@ -604,8 +603,7 @@ sub save_dunning {
       }
       if ($form->{inv_ids} ne "") {
         $form->{inv_ids} .= ")";
-        #print(STDERR "Rufe save_dunning_auf für Zeile $form->{inv_ids} von Kunde $lastcustomer\n");
-       DN->save_dunning(\%myconfig, \%$form, \@rows, $userspath,$spool, $sendmail);
+        DN->save_dunning(\%myconfig, \%$form, \@rows, $userspath,$spool, $sendmail);
       }
     }
   } else {
@@ -614,12 +612,10 @@ sub save_dunning {
         @rows = ();
         $form->{inv_ids} = qq|($form->{"inv_id_$i"})|;
         push(@rows, $i);
-        #print(STDERR "Rufe save_dunning_auf für Zeile $i\n");
         DN->save_dunning(\%myconfig, \%$form, \@rows, $userspath,$spool, $sendmail);
       }
     }
   }
-  #print(STDERR Dumper($form->{DUNNING_PDFS}));
   if($form->{DUNNING_PDFS}) {
     DN->melt_pdfs(\%myconfig, \%$form,$spool);
   }
diff --git a/bin/mozilla/io.pl b/bin/mozilla/io.pl
index 1c84ef1bf..b88d36dde 100644
--- a/bin/mozilla/io.pl
+++ b/bin/mozilla/io.pl
@@ -363,7 +363,6 @@ sub display_row {
                                  $decimalplaces)
           . qq|></td>|;
       }
-    print(STDERR "Sellprice vor Ausgabe: ",$form->{"sellprice_$i"},"\n"); 
 
       $column_data{sellprice} =
         qq|<td><input name="sellprice_$i" size=10 value=|